      **********************************************************************
      * Copy Book of SRVPGMCPY
      * Modification log:
      * ??/??/99 by R.Berendt, CCP   of Group Dekko Services, LLC
      *          Created
      * 03/17/99 by R.Berendt, CCP   of Group Dekko Services, LLC
      *          Modified dateedit to do it's own capitilization.
      *          Removed procedure caps.
      *          This made dateedit run 22 times faster.  Test went from
      *          3,609 seconds down to 159.
      * 09/12/01 by CTS01
      *          Rename API fields to unique names in DEVD0100, DEVD0600, and
      *          JOBD0100.  Standardize and add API prototypes and DS.
      *          Add string functions Center, CtoN (character to numeric).
      * 02/01/02 by R.Berendt, CCP   of Group Dekko Services, LLC
      *          Added subprocedures:  FAXA, FAXN, FAXAREACODE, FAXEXCHANGE
      * 04/11/02 by R.Berendt, CCP   of Group Dekko Services, LLC
      *          Added subprocedures:  CHECKRMTDB
      * 05/15/02 by R.Berendt, CCP   of Group Dekko Services, LLC
      *          Wanted ability to check area code using Zip Code.  Thus I added
      *          The following subprocedures:
      * 03/31/04 by CTS02
      *          Add string function ScanGen - Scan string for generic pattern.
      *

      ***************************************************************************
      * Date functions                                                          *
      ***************************************************************************

     D AddDays         PR             8S 0
     D  FromDate                           CONST Like(AddDays)
     D  Spread                        5S 0 CONST

     D DateEdit        PR             8S 0
     D  FromDate                           CONST like(DateEdit)
     D  FromFmt                       8A   CONST
     D  ToFmt                         8A   CONST

     D DayOfWeek       PR             1S 0
     D  AnyDate                        D   CONST DATFMT(*USA)

     D DayNameL        PR             9A
     D  AnyDate                        D   CONST DATFMT(*USA)

     D DayNameS        PR             3A
     D  AnyDate                        D   CONST DATFMT(*USA)

     D DaysDiff        PR             5S 0
     D  FromDate                      8S 0 CONST
     D  ToDate                        8S 0 CONST

      ***************************************************************************
      * Prototypes for C functions needed in RPG IV Free Stuff                  *
      ***************************************************************************
      * You _MUST_ specify the bind directory QC2LE on the CRTxxx command
      *   when using any of these functions
      /If defined(PrintAll)
      * These functions include:
      *   Cosine
      *   Log
      *   Sine
      *   Tangent
      /EndIf

     D Cosine          PR             8F   ExtProc('cos')
     D  Double                        8F   Value

     D Log             PR             8F   ExtProc('log')
     D  Double                        8F   Value

     D Sine            PR             8F   ExtProc('sin')
     D  Double                        8F   Value

     D Tangent         PR             8F   ExtProc('tan')
     D  Double                        8F   Value

      ***************************************************************************
      * String functions                                                        *
      ***************************************************************************
      * Center a string
     D Center          PR         32767A
     D  Input                     32767A   CONST VARYING
     D  CtrLen                        5  0 CONST

      * Character to numeric
     D CtoN            PR            30P 9
     D   PR_Char                  32767A   CONST VARYING

      * Scan string for generic pattern
     D ScanGen         PR             5P 0
     D  PatStr                    32767A   CONST VARYING
     D  NewStr                    32767A   CONST VARYING
     D  StartPos                      5P 0 CONST OPTIONS(*NOPASS)

     D SplJob          PR            28A
     D  JobName                      10A
     D  JobUser                      10A
     D  JobNumber                     6A

     D IFSTempFile     PR            33A
     D  JobName                      10A
     D  JobUser                      10A
     D  JobNumber                     6A

     D SendTo          PR         32702A
     D  Recepient                  3000A   CONST
     D  Subject                      50A   CONST
     D  File_Lib                     20A

      ***************************************************************************
      * Command processing                                                      *
      ***************************************************************************
      /If not defined(QCMDEXC)
      /INCLUDE ROUTINES/QAPISRC,QCMDEXC
      /EndIf


     D ExecCmd         PR             5S 0
     D  cmd                       32702A   CONST

      /INCLUDE ROUTINES/QAPISRC,QCAPCMD

      * Run a command using QCAPCMD API
     D RunCmdAPI       PR                  LIKE(ExceptionId)
     D  CmdParm                            CONST like(Cmd)

      /INCLUDE ROUTINES/QAPISRC,SYSTEM

      ***************************************************************************
      * BPCS API's                                                              *
      ***************************************************************************
     D CompanyName     PR            40A

      * Center a 40 character string.  Useful for company name on headings.
     D Center40        PR            40A
     D  Input                        40A   CONST OPTIONS(*VARSIZE)

      ***************************************************************************
      * System API's - No list                                                  *
      ***************************************************************************
      /If not defined(qmhsndpm)
      /INCLUDE ROUTINES/QAPISRC,QMHSNDPM
      /EndIf

      /Define qmhsndm
      * Send a non-program message.
     D qmhsndm         PR                  EXTPGM('QMHSNDM')
     D  MessageId                     7A   CONST
     D  MessageFile                  20A   CONST
     D  MsgDataOrText               300A   CONST OPTIONS(*VARSIZE)
     D  MsgDataLen                    9B 0 CONST
     D  MessageType                  10A   CONST
     D  QueueList                    20A   CONST OPTIONS(*VARSIZE)
     D  NbrQueues                     9B 0 CONST
     D  ReplyQueue                   20A   CONST
     D  MessageKey                    4A
     D  ErrorCode                          LIKE(ERRC0100)

      /Define qmhrtvm
      * Retrieve a message.
     D qmhrtvm         PR                  EXTPGM('QMHRTVM')
     D  RetrievedMsg               3000A   VARYING OPTIONS(*VARSIZE)
     D  RtvMsgLen                     9B 0 CONST
     D  RtvMsgFmt                     8A   CONST
     D  RtvMsgId                      7A   CONST
     D  RtvMsgFileLib                20A   CONST
     D  RtvMsgData                32767A   CONST OPTIONS(*VARSIZE)
     D  RtvMsgDataLen                 9B 0 CONST
     D  RtvMsgSubVar                 10A   CONST
     D  RtvMsgFmtChr                 10A   CONST
     D  ErrorCode                          LIKE(ERRC0100)

      /If not defined(rcvm0200)
      /INCLUDE ROUTINES/QAPISRC,RCVM0200
      /EndIf

      * Start Windows Network Neighborhood Server
     D qzlsstrs        PR                  EXTPGM('QZLSSTRS')
     D  ResetServer                   1A   CONST
     D  qzlsstrsErr                        LIKE(ERRC0100)
     D StrNetSvrP      PR                  Like(ERRC0100)
     D  ResetServer                   1A   CONST

      * Open Stream File defined in HFS
     D qhfopnsf        PR                  EXTPGM('QHFOPNSF')
     D  Parm                               like(OpenHandle) CONST
     D  Parm                               like(PathName)
     D  Parm                               like(PathNameLen)
     D  Parm                               like(OpenInfo)
      * Description of OpenInfo
      * Byte 1:  Action if file exists
      *   0-Do not open file.  Error out.
      *   1-Open file.
      *   2-Replace file.
      * Byte 2:  Action if file does not exist
      *   0-Return an error
      *   1-Create the file
      * Byte 3:  Write when,
      *   0-Asynchronous, write later, beware of power failure
      *   1-Synchronous, Write now.
      * Byte 4:  Reserved, must be blank
      * Byte 5:  File lock mode - what other jobs may do
      *   1-Deny None
      *   2-Deny write
      *   3-Deny Read
      *   4-Deny Read/Write (exclusive)
      * Byte 6:  How are we using the file
      *   0-Read only
      *   1-Write only
      *   2-Read/Write
      * Byte 7:  Type of open
      *   0-Normal
      *   1-Permanent.  Close either by QHFCLOSE or by end of job.
      * Byte 8-10:  Reserved, must be blank.
     D  Parm                               like(HfsAttrInfo)
     D  Parm                               like(HfsAttrLen)
     D  Parm                               like(OpenAction)
      * What action happened on open?
      *  1-File already existed and was not replaced.
      *  2-File did not exist and was created.
      *  3-File already existed and was replaced.
     D  Parm                               LIKE(ERRC0100)

      /Define qhfrdsf
      * Read Stream File defined in HFS
     D qhfrdsf         PR                  EXTPGM('QHFRDSF')
     D  Parm                               like(OpenHandle) CONST
     D  Parm                               like(DataBuffer)
     D  Parm                               like(BytestoRead)
     D  Parm                               like(BytesRead)
     D  Parm                               like(ERRC0100)

      /Define qhfclosf
      * Close Stream File defined in HFS
     D qhfclosf        PR                  EXTPGM('QHFCLOSF')
     D  Parm                               like(OpenHandle) CONST
     D  Parm                               like(ERRC0100)

      /If not defined(qclrdtaq)
      /INCLUDE ROUTINES/QAPISRC,QCLRDTAQ
      /EndIf

      /If not defined(qrcvdtaq)
      /INCLUDE ROUTINES/QAPISRC,QRCVDTAQ
      /EndIf

      /If not defined(qsnddtaq)
      /INCLUDE ROUTINES/QAPISRC,QSNDDTAQ
      /EndIf

      /If not defined(QSYRUSRI)
      /Include ROUTINES/QAPISRC,QSYRUSRI
      /EndIf


      /Define QDCRDEVD
      * Retrieve Device Description
     D QDCRDEVD        PR                  EXTPGM('QDCRDEVD')
     D  RecVar                     3000A   OPTIONS(*VARSIZE)                    Receiver variable
     D  RecVarLen                    10I 0 CONST                                Receiver var length
     D  FormatName                    8A   CONST                                Format name
     D  Device                       10A   CONST                                Retrieve user prf
     D  ErrorCode                          LIKE(ERRC0100)                       Error code

      /Define QWCRDTAA
      * Retrieve Data Area
     D QWCRDTAA        PR                  EXTPGM('QWCRDTAA')
     D  RecVar                     3000A   OPTIONS(*VARSIZE)                    Receiver var
     D  RecVarLen                    10I 0 CONST                                Receiver var length
     D  QDtaAName                    20A   CONST                                Qual data area name
     D  StartPos                     10I 0 CONST                                Start Position
     D  DataLen                      10I 0 CONST                                Retrieve Length
     D  ErrorCode                          Like(ERRC0100)                       Error code

      /Define QWDRJOBD
      * Retrieve Job Description
     D QWDRJOBD        PR                  EXTPGM('QWDRJOBD')
     D  RecVar                     3000A   OPTIONS(*VARSIZE)                    Receiver variable
     D  RecVarLen                    10I 0 CONST                                Receiver var length
     D  FormatName                    8A   CONST                                Format name
     D  JobDFLib                     20A   CONST                                Job description name
     D  ErrorCode                          LIKE(ERRC0100)                       Error code

      /If not defined(QUSRJOBI)
      /Include ROUTINES/QAPISRC,QUSRJOBI
      /EndIf

      /If not defined(QUSROBJD)
      /Include ROUTINES/QAPISRC,QUSROBJD
      /EndIf

      ***************************************************************************
      * System API's - List                                                     *
      ***************************************************************************
      /If not defined(QUSLJOB)
      /Include ROUTINES/QAPISRC,QUSLJOB
      /EndIf

      /If not defined(QUSLOBJ)
      /Include ROUTINES/QAPISRC,QUSLOBJ
      /EndIf

      /Define qbnlpgmi
      * List ILE Program Information
     D qbnlpgmi        PR                  extpgm('QBNLPGMI')
     D  UserSpace                          CONST like(Obj_Lib)
     D  FormatName                    8A   CONST
     D  ILEPgm                             CONST like(Obj_Lib)
     D  ErrorCode                          like(errc0100)

      /Define qbnlspgm
      * List Service Program Information
     D qbnlspgm        PR                  extpgm('QBNLSPGM')
     D  UserSpace                          CONST like(Obj_Lib)
     D  FormatName                    8A   CONST
     D  SrvPgm                             CONST like(Obj_Lib)
     D  ErrorCode                          like(errc0100)

     D CheckPrf        PR              N
     D   UserProfile                       like(UserId)

     D SndBrkUsr       PR                  EXTPGM('SNDBRKUSR')
     D   UserProfile                       like(UserId)
     D   Message                           like(BrkMsg)

      ***************************************************************************
      * System API's - User spaces                                              *
      ***************************************************************************
      /INCLUDE ROUTINES/QAPISRC,QUSDLTUS
      /INCLUDE ROUTINES/QAPISRC,QUSCRTUS
      /INCLUDE ROUTINES/QAPISRC,QUSRTVUS
      /INCLUDE ROUTINES/QAPISRC,QUSPTRUS

      ***************************************************************************
      * Phone number subprocedures                                              *
      ***************************************************************************

     D*--------------------------------------
     D* Prototype for procedure: FAX400CVT
     D*--------------------------------------
     D FAX400CVT       PR                  EXTPGM('FAX400CVT')
     D PHONE                         15A   CONST
     D FAX#                          30A

     D*--------------------------------------
     D* Prototype for procedure: FAXA
     D*--------------------------------------
     D FAXA            PR                  LIKE(Fax#)
     D Phone                         30A   CONST

     D*--------------------------------------
     D* Prototype for procedure: FAXN
     D*--------------------------------------
     D FAXN            PR                  LIKE(Fax#)
     D Phone                         30P 0 CONST

     D*--------------------------------------
     D* Prototype for procedure: FAXAREACODE
     D*--------------------------------------
     D FAXAREACODE     PR             3A
     D FaxNbr                              LIKE(Fax#) CONST

     D*-------------------------------------
     D* Prototype for procedure: FAXEXCHANGE
     D*-------------------------------------
     D FAXEXCHANGE     PR             3A
     D FaxNbr                              LIKE(Fax#) CONST

     D*-----------------------------------
     D* Prototype for procedure: FAXNUMBER
     D*-----------------------------------
     D FAXNUMBER       PR             4A
     D FaxNbr                              LIKE(Fax#) CONST

     D*--------------------------------------
     D* Prototype for procedure: FAXNEWPHONEA
     D*--------------------------------------
     D FAXNEWPHONEA    PR            30A
     D OldPhone                      30A   CONST

     D*--------------------------------------
     D* Prototype for procedure: FAXNEWPHONEN
     D*--------------------------------------
     D FAXNEWPHONEN    PR            30P 0
     D OldPhone                      30P 0 CONST

     D*--------------------------------------
     D* Prototype for procedure: FAXNEWSTRING
     D*--------------------------------------
     D FAXNEWSTRING    PR            30A
     D OldString                     30A   CONST
     D NewAreaCode                    3A   CONST
     D Exchange                       3A   CONST
     D Phone#                         4A   CONST

     D*--------------------------------------
     D* Prototype for procedure: FAXAREAZIP
     D*--------------------------------------
     D FAXAREAZIP      PR             3A
     D Fax#                          30A   CONST
     D ZipCode                        5A   CONST

     D*-----------------------------------
     D* Prototype for procedure: CHECKDB
     D* Checks for existance.
     D* If you pass it 1 parameter it checks for the existance of the library.
     D* If you pass it 2 parameters it checks for the existance of the file.
     D* If you pass it 3 parameters it checks for the existance of the field.
     D*-----------------------------------
     D checkdb         PR              n
     D library                       10A   CONST
     D File                          10A   CONST OPTIONS(*NOPASS)
     D field                         10A   CONST OPTIONS(*NOPASS)

     D*-----------------------------------
     D* Prototype for procedure: CHECKRMTDB
     D* Checks for existance.
     D* If you pass it 1 parameter it checks for the connection to the remote.
     D* If you pass it 2 parameter it checks for the existance of the library.
     D* If you pass it 3 parameters it checks for the existance of the file.
     D* If you pass it 4 parameters it checks for the existance of the field.
     D*-----------------------------------
     D checkrmtdb      PR              n
     D remote                        10A   CONST
     D library                       10A   CONST OPTIONS(*NOPASS)
     D File                          10A   CONST OPTIONS(*NOPASS)
     D field                         10A   CONST OPTIONS(*NOPASS)

     D*-----------------------------------
     D* Prototype for procedure: CountSbsJobs
     D* Will count the number of jobs still running in a subsystem.
     D* Procedure name: CountSbsJobs
     D* Purpose: Count the number of jobs running in a subsystem
     D* Returns:  The number of jobs in that subsystem
     D*             >1 = Number of jobs running in subsystem + 1 for the subsystem
     D*             1  = Only the subsystem is active
     D*             0  = Subsystem not active
     D*             -2 = Ended in error
     D* Parameter:      Subsystem name
     D*-----------------------------------
     D CountSbsJobs    PR             5i 0
     D  Subsystem                    10A   CONST

      /If not defined(EXCPHDLR01)
      /Include ROUTINES/QPROTOSRC,EXCPHDLR01
      /EndIf


     D*--------------------------------------
     D* Procedure name: FNDSIGMSG
     D* Purpose: Find the SIGnificant message
     D* Returns: Copy of Program Status Data Structure
     D* Parameter:  Copy of Program Status Data Structure
     D*             Stack count of program message queue (optional)
     D*--------------------------------------
     D FNDSIGMSG       PR                  like(mypsds)
     D  ParmPSDS                           likeds(mypsds) const
     D  StackCount                         like(StackCnt) options(*nopass) const


      ***************************************************************************
      * Constants                                                               *
      ***************************************************************************
     D Pi              C                   3.14159265358979323846

      /If not defined(LWRUPR)
      /INCLUDE ROUTINES/QRPGLESRC,LWRUPR
      /EndIf

      ***************************************************************************
      * File status codes                                                       *
      ***************************************************************************
     D NoError         C                   0
     D EndOfFile       C                   11
     D RecordNotFound  C                   12
     D DuplicateKey    C                   1021
     D ReferentialErr  C                   1022
     D TriggerErrBef   C                   1023
     D TriggerErrAft   C                   1024
     D YouAreOld       C                   1031
     D FileClosed      C                   1211
     D FileOpen        C                   1215
     D ImpOpenCloseEr  C                   1216
     D ExpOpenCloseEr  C                   1217
     D RecAlreadyLock  C                   1218
     D UpdBeforeRead   C                   1221
     D RefErrOnAlloc   C                   1222
     D PermIOErr       C                   1251
     D JobEndingCtl    C                   1282

      ***************************************************************************
      * System API's data structures                                            *
      ***************************************************************************
      /If not defined(errc0100)
      /INCLUDE ROUTINES/QAPISRC,ERRC0100
      /EndIf


      * RTVM0100 - QMHRTVM - Retrieve Message
     D RTVM0100        DS
     D  RTM1BytesRet                  9B 0
     D  RTM1BytesAvl                  9B 0
     D  RTM1LenMsgRet                 9B 0
     D  RTM1LenMsgAvl                 9B 0
     D  RTM1LenHlpRet                 9B 0
     D  RTM1LenHlpAvl                 9B 0
     D  RTM1Msg                    3000A   VARYING
     D  RTM1Hlp                    3000A   VARYING

      * Stream File API's from HFS.
     D OpenHandle      S             16A
     D PathName        S            300A
     D PathNameLen     S              9B 0
     D PtrPathName     S               *   inz(%addr(PathName))
     D OpenInfo        S             10A
     D HfsAttrInfo     S          32767A   VARYING
     D HfsAttrLen      S              9B 0
     D OpenAction      S              1A
     D DataBuffer      S          32767A   VARYING
     D BytestoRead     S              9B 0
     D BytesRead       S              9B 0
     D MsgKey          S              4A
     D StackCnt        s             10i 0                                      see QMHRCVPM

      * DataQueSender - QRCVDTAQ - Sendar Data
     D DataQueSender   DS
     D  DQBytesRet                    7P 0
     D  DQBytesAvl                    7P 0
     D  DQJobName                    10A
     D  DQUser                       10A
     D  DQJobNbr                      6A
     D  DQCurSender                  10A

      /If not defined(RDTAARA)
      /Include ROUTINES/QAPISRC,RDTAARA
      /EndIf

      /If not defined(USRI0100)
      /INCLUDE ROUTINES/QAPISRC,USRI0100
      /EndIf
      /If not defined(USRI0200)
      /INCLUDE ROUTINES/QAPISRC,USRI0200
      /EndIf
      /If not defined(USRI0300)
      /INCLUDE ROUTINES/QAPISRC,USRI0300
      /EndIf

      * DEVD0600 - QDCRDEVD - Retrieve Device Description - Device category *DSP
     D DEVD0600        DS
      *  DEVD0100 - QDCRDEVD - Retrieve Device Description - Basic device information
     D  DEVD0100
     D   DDBytesRet                   9B 0  OVERLAY(DEVD0100)                   Bytes returned
     D   DDBytesAvl                   9B 0  OVERLAY(DEVD0100:*NEXT)             Bytes available
     D   DDDateInfo                   7A    OVERLAY(DEVD0100:*NEXT)             Date info retrieved
     D   DDTimeInfo                   6A    OVERLAY(DEVD0100:*NEXT)             Time info retrieved
     D   DDDevName                   10A    OVERLAY(DEVD0100:*NEXT)             Device name
     D   DDDevCat                    10A    OVERLAY(DEVD0100:*NEXT)             Device category
     D   DDOnlnIPL                   10A    OVERLAY(DEVD0100:*NEXT)             Online at IPL
     D   DDDevDesc                   50A    OVERLAY(DEVD0100:*NEXT)             Text description
     D   DDRes1                       3A    OVERLAY(DEVD0100:*NEXT)             Reserved
     D  DDCIDGraph                    9B 0                                      Chr ID graph chr set
     D  DDCIDCodPg                    9B 0                                      Chr ID code page
     D  DDMaxLenRU                    9B 0                                      Max length req unit
     D  DDInactTim                    9B 0                                      Inactivity timer
     D  DDDBCS_RAM                    9B 0                                      DBCS feature RAM siz
     D  DDActTimer                    9B 0                                      Activation timer
     D  DDSwtchSet                    9B 0                                      Switch setting
     D  DDPort                        9B 0                                      Device port
     D  DDMaxOutFm                    9B 0                                      Max outstndng frames
     D  DDIdleTimr                    9B 0                                      Idle timer
     D  DDNRMPollT                    9B 0                                      NRM poll timer
     D  DDFrmRetry                    9B 0                                      Frame retry
     D  DDOffAuxDv                    9B 0                                      Offset list aux dev
     D  DDNbrAuxDv                    9B 0                                      Number auxiliary dev
     D  DDLenAuxDv                    9B 0                                      Entry len aux dev
     D  DDDevClass                   10A                                        Device class
     D  DDDevType                    10A                                        Device type
     D  DDDevModel                   10A                                        Device model
     D  DDLoclLocA                   10A                                        Local loc address
     D  DDNonSwCtl                   10A                                        Nonswitched cntrlr
     D  DDKbdLang                    10A                                        Keyboard lang type
     D  DDDropLine                   10A                                        Drop line at signoff
     D  DDAlwBlink                   10A                                        Allow blink cursor
     D  DDPrtDev                     10A                                        Print device
     D  DDRmtLocNm                   10A                                        Remote location name
     D  DDLoclLoc                    10A                                        Local location name
     D  DDRmtNetID                   10A                                        Remote network ID
     D  DDCSessDvD                   10A                                        Cntrl sess dev desc
     D  DDAsPrtNam                   10A                                        Assoc printer name
     D  DDAsPrRNID                   10A                                        Assoc prtr rmt netID
     D  DDAltPrtr                    10A                                        Alt printer name
     D  DDAltPrNID                   10A                                        Alt prtr network ID
     D  DDOutQ                       10A                                        Output queue name
     D  DDOutQLib                    10A                                        Output queue library
     D  DDPrinter                    10A                                        Printer
     D  DDPrtFile                    10A                                        Print file name
     D  DDPrtLib                     10A                                        Print file library
     D  DDWsCsONam                   10A                                        Wkstn custz obj name
     D  DDWsCsOLib                   10A                                        Wkstn custz obj lib
     D  DDAppType                    10A                                        Application type
     D  DDDBCSMtrx                   10A                                        DBCS matrix size
     D  DDDBCSLang                   10A                                        DBCS language ID
     D  DDDBCSLCP                    10A                                        DBCS last code print
     D  DDSNADev                     10A                                        SNA pass-thru device
     D  DDSNAGrp                     10A                                        SNA pass-thru group
     D  DDEmuDev                     10A                                        Emulated device
     D  DDEmuModel                   10A                                        Emulated dev model
     D  DDEmuASCII                   10A                                        Emulating ASCII dev
     D  DDPhyAttch                   10A                                        Physical attachment
     D  DDLinSpeed                   10A                                        Line speed
     D  DDWordLen                    10A                                        Word length
     D  DDParityTy                   10A                                        Parity type
     D  DDStopBits                   10A                                        Stop bits
     D  DDASCII_ID                   20A                                        ASCII terminal ID
     D  DDAsAPPCDv                   10A                                        Assoc APPC device
     D  DDHstSnCmd                  256A                                        Host signon command
     D  DDPassThIn                    1A                                        Pass-thru indicator
     D  DDAutoCfg                    10A                                        Auto configured
     D  DDRes2                        3A                                        Reserved
     D  DDShrdSess                    9B 0                                      Shared session num
     D  DDDepndLoc                   10A                                        Dependent location
     D  DDNetProto                    1A                                        Network protocol
     D  DDNetProAd                   18A                                        Netwrk protocol addr
     D  DDIPAddr                     15A                                        IP address
     D  DDAllocJob                   10A                                        Alloc by job name
     D  DDAllocUsr                   10A                                        Alloc by user name
     D  DDAllocNbr                   10A                                        Alloc by job number
     D  DDCurrMsgQ                   10A                                        Current msg queue
     D  DDCurrMsgL                   10A                                        Current msg library
     D  DDSerNetP                     1A                                        Servr netwk protocol
     D  DDSerNetPA                   18A                                        Srvr net protoc addr
     D  DDSerIPAdd                   15A                                        Srvr IP address

      * JOBD0100 - QWDRJOBD - Retrieve Job Description Information - Basic job information
     D JOBD0100        DS
     D  JDBytesRet                    9B 0                                      Bytes returned
     D  JDBytesAvl                    9B 0                                      Bytes available
     D  JDJobDName                   10A                                        Job description name
     D  JDJobDLib                    10A                                        Job description lib
     D  JDUserName                   10A                                        User name
     D  JDJobDate                     8A                                        Job date
     D  JDJobSws                      8A                                        Job switches
     D  JDJobQName                   10A                                        Job queue name
     D  JDJobQLib                    10A                                        Job queue library
     D  JDJobQPty                     2A                                        Job queue priority
     D  JDHoldJobQ                   10A                                        Hold on job queue
     D  JDOutQName                   10A                                        Output queue name
     D  JDOutQLib                    10A                                        Output queue lib
     D  JDOutQPty                     2A                                        Output queue priorty
     D  JDPrtDev                     10A                                        Printer device name
     D  JDPrtTxt                     30A                                        Print text
     D  JDSynSev                      9B 0                                      Syntax check severty
     D  JDEndSev                      9B 0                                      End severity
     D  JDLogSev                      9B 0                                      Message log severity
     D  JDLogLvl                      1A                                        Message log level
     D  JDLogTxt                     10A                                        Message log text
     D  JDLogCLPgm                   10A                                        Log CL programs
     D  JDInqMsgRy                   10A                                        Inquiry msg reply
     D  JDDevRcvAn                   13A                                        Device recovery actn
     D  JDTSEPool                    10A                                        Time-slice end pool
     D  JDAcgCde                     15A                                        Accounting code
     D  JDRtgDta                     80A                                        Routing data
     D  JDTxtDsc                     50A                                        Text description
     D  JDRes1                        1A                                        Reserved
     D  JDOffLibL                     9B 0                                      Offset init lib list
     D  JDNbrLibL                     9B 0                                      Num libs init libl
     D  JDOffRqDta                    9B 0                                      Offset request data
     D  JDLenRqDta                    9B 0                                      Length request data
     D  JDJobMsgQM                    9B 0                                      Job msg queue max
     D  JDJobMsgQF                   10A                                        Job msg queue full
     D  JDCYMDJobD                   10A                                        CYMD job date
     D  JDAlwMltTh                   10A                                        Allow multi threads

      * JOBI0700 - QUSRJOBI - Retrieve Job Information - Library list information
     D JOBI0700        DS          5000
     D  JIBytesRet                   10I 0                                      Bytes returned
     D  JIBytesAvl                   10I 0                                      Bytes available
     D  JIJobNam                     10A                                        Job name
     D  JIUserNam                    10A                                        User name
     D  JIJobNum                      6A                                        Job number
     D  JIJobID                      16A                                        Internal job ID
     D  JIJobSts                     10A                                        Job status
     D  JIJobTyp                      1A                                        Job type
     D  JIJobSTyp                     1A                                        Job subtype
     D  JIRes7                        2A                                        Reserved
     D  JINumSLibs                   10I 0                                      Num libs in SYSLIBL
     D  JINumPLibs                   10I 0                                      Num product libs
     D  JICurLibEx                   10I 0                                      Curr lib existence
     D  JINumULibs                   10I 0                                      Num libs in USRLIBL

      * OBJD0400 - QUSROBJD - Retrieve Object Description - Full information
     D OBJD0400        DS
      *  OBJD0300 - QUSROBJD - Retrieve Object Description - Service information
     D  OBJD0300
      *   OBJD0200 - QUSROBJD - Retrieve Object Description - PDM information
     D   OBJD0200                          OVERLAY(OBJD0300)
      *    OBJD0100 - QUSROBJD - Retrieve Object Description - Basic information
     D    OBJD0100                         OVERLAY(OBJD0200)
     D     OBBytesRet                10I 0 OVERLAY(OBJD0100)                    Bytes returned
     D     OBBytesAvl                10I 0 OVERLAY(OBJD0100:*NEXT)              Bytes available
     D     OBObjNam                  10A   OVERLAY(OBJD0100:*NEXT)              Object name
     D     OBObjLib                  10A   OVERLAY(OBJD0100:*NEXT)              Object library
     D     OBObjTyp                  10A   OVERLAY(OBJD0100:*NEXT)              Object type
     D     OBRetLib                  10A   OVERLAY(OBJD0100:*NEXT)              Return library
     D     OBASP                     10I 0 OVERLAY(OBJD0100:*NEXT)              Auxil storage pool
     D     OBOwn                     10A   OVERLAY(OBJD0100:*NEXT)              Object owner
     D     OBDomain                   2A   OVERLAY(OBJD0100:*NEXT)              Object domain
     D     OBCrtTS                   13A   OVERLAY(OBJD0100:*NEXT)              Create dat/tim
     D     OBChgTS                   13A   OVERLAY(OBJD0100:*NEXT)              Obj change dat/tim
     D    OBExtAtr                   10A   OVERLAY(OBJD0200:*NEXT)              Extended obj atrrib
     D    OBDesc                     50A   OVERLAY(OBJD0200:*NEXT)              Text description
     D    OBSrcFil                   10A   OVERLAY(OBJD0200:*NEXT)              Source file name
     D    OBSrcLib                   10A   OVERLAY(OBJD0200:*NEXT)              Source file library
     D    OBSrcMbr                   10A   OVERLAY(OBJD0200:*NEXT)              Source file member
     D   OBSrcTS                     13A   OVERLAY(OBJD0300:*NEXT)              Src fil upd dat/tim
     D   OBSavTS                     13A   OVERLAY(OBJD0300:*NEXT)              Obj saved dat/tim
     D   OBRstTS                     13A   OVERLAY(OBJD0300:*NEXT)              Obj restored dat/tim
     D   OBCrtBy                     10A   OVERLAY(OBJD0300:*NEXT)              Creator user profile
     D   OBCrtSys                     8A   OVERLAY(OBJD0300:*NEXT)              System obj created
     D   OBResetDt                    7A   OVERLAY(OBJD0300:*NEXT)              Reset date
     D   OBSavSize                   10I 0 OVERLAY(OBJD0300:*NEXT)              Save size
     D   OBSavSeq                    10I 0 OVERLAY(OBJD0300:*NEXT)              Save seq numbers
     D   OBStorage                   10A   OVERLAY(OBJD0300:*NEXT)              Storage
     D   OBSavCmd                    10A   OVERLAY(OBJD0300:*NEXT)              Save command
     D   OBSavVol                    71A   OVERLAY(OBJD0300:*NEXT)              Save volume ID
     D   OBSavDev                    10A   OVERLAY(OBJD0300:*NEXT)              Save device
     D   OBSavFil                    10A   OVERLAY(OBJD0300:*NEXT)              Save file name
     D   OBSavFLib                   10A   OVERLAY(OBJD0300:*NEXT)              Save file lib
     D   OBSavLbl                    17A   OVERLAY(OBJD0300:*NEXT)              Save label
     D   OBSysLvl                     9A   OVERLAY(OBJD0300:*NEXT)              System level
     D   OBCompiler                  16A   OVERLAY(OBJD0300:*NEXT)              Compiler
     D   OBObjLvl                     8A   OVERLAY(OBJD0300:*NEXT)              Object level
     D   OBUsrChg                     1A   OVERLAY(OBJD0300:*NEXT)              User changed
     D   OBLicPgm                    16A   OVERLAY(OBJD0300:*NEXT)              Licensed program
     D   OBPTF                       10A   OVERLAY(OBJD0300:*NEXT)              Pgm temporary fix
     D   OBAPAR                      10A   OVERLAY(OBJD0300:*NEXT)              Auth pgm anal rpt
     D  OBLastUsed                    7A                                        Last-used date
     D  OBUsageU                      1A                                        Usage information
     D  OBDaysUsed                   10I 0                                      Days-used count
     D  OBObjSiz                     10I 0                                      Object size
     D  OBSizMul                     10I 0                                      Obj size multiplier
     D  OBObjCmp                      1A                                        Obj compress status
     D  OBAlwChg                      1A                                        Allow change by pgm
     D  OBChgPgm                      1A                                        Changed by pgm
     D  OBUsrAtr                     10A                                        User-define attrib
     D  OBASPOF                       1A                                        Obj overflow ASP ind
     D  OBSavActTS                   13A                                        Save active dat/tim
     D  OBObjAud                     10A                                        Obj auditing value
     D  OBPriGrp                     10A                                        Primary group
     D  OBJnlSts                      1A                                        Journal status
     D  OBJnlNam                     10A                                        Journal name
     D  OBJnlLib                     10A                                        Journal library
     D  OBJnlImgs                     1A                                        Journal images
     D  OBJnlOmit                     1A                                        Journal entries omit
     D  OBJnlStrTS                   13A                                        Journal strt dat/tim
     D  OBDigSign                     1A                                        Digitally signed
     D  OBSavSiz                     10I 0                                      Saved size in units
     D  OBSavSizM                    10I 0                                      Saved size multiplr

      * JOBL0100 - QUSLJOB - List Job - Basic job list
     D pJOBL0100       S               *                                        Ptr job list
     D JOBL0100        DS                  Based(pJOBL0100)
     D  JLJobNam                     10A                                        Job name used
     D  JLUsrNam                     10A                                        User name used
     D  JLJobNbr                      6A                                        Job number used
     D  JLJobID                      16A                                        Internal job ID
     D  JLJobSts                     10A                                        Status
     D  JLJobTyp                      1A                                        Job type
     D  JLSubtyp                      1A                                        Job subtype
     D  JLRes1                        2A                                        Reserved

      * JOBL0200 - QUSLJOB - List Job - Basic job list with keyed return fields
     D pJOBL0200       S               *                                        Ptr job list
     D JOBL0200        DS                  Based(pJOBL0200) Qualified
     D  JobNam                       10A                                        Job name used
     D  UsrNam                       10A                                        User name used
     D  JobNbr                        6A                                        Job number used
     D  JobID                        16A                                        Internal job ID
     D  JobSts                       10A                                        Status
     D  JobTyp                        1A                                        Job type
     D  Subtyp                        1A                                        Job subtype
     D  Res1                          2A                                        Reserved
     D  JobInfoSts                    1A                                        Job information Sts
     D  Res2                          3a                                        Reserved
     D  NbrFldsRet                   10i 0                                      Number of Fields ret
      * JOBL0200B - QUSLJOB - List job, key info
     D pJOBL0200B      S               *                                        Ptr key list
     D JOBL0200B       DS                  Based(pJOBL0200B) Qualified
     D  LenFldInfoRet                10i 0                                      Length of info ret
     D  KeyFld                       10i 0                                      Field key
     D  DataType                      1a                                        Type of data
     D  res1                          3a                                        Reserved
     D  DataLen                      10i 0                                      Length of data

      /If not defined(OBJL)
      /Include ROUTINES/QAPISRC,OBJL
      /EndIf

      /If not defined(GH0100)
      /INCLUDE ROUTINES/QAPISRC,GH0100
      /EndIf

      * Format CPOP0100 for Process Command (QCAPCMD) API.  QCAPCMD is a
      * better alternative for QCMDEXC.
     D CPOP0100        DS
     D  CPOPType                     10I 0
      *         0=Command running.  Like QCMDEXC.
      *         1=Command syntax check.  Like QCMDCHK.
      *         2=Command line running.  Will prompt for missing required
      *           parameters.
      *         3=Command line syntax check.  Like QCMDCHK but with check
      *           only complement of option 2.
      *         4=CL program statement.  Edits the command like SEU would.
      *         5=CL input stream.  Checked according to rules for CL
      *           batch jobs, (CL, not CLP).
      *         6=Command definition statements.  Syntax is checked for
      *           statements used to make *CMD objects.
      *         7=Binder definition statements are syntax checked.
      *         8=User-defined option.  See the manual.
      *         9=ILE CL program source.  Syntax is checked as if it
      *           were for a CLLE program.
     D  CPOPDBCS                      1A
      *         '0'=Ignore DBCS data
      *         '1'=Handle DBCS data
     D  CPOPPmtAcn                    1A
      *         0=Never prompt the command.
      *         1=Always prompt the command.
      *         2=Prompt the command if selective prompting characters are
      *           present in the command string.
      *         3=Show help.
     D  CPOPCmdSyn                    1A
      *         0=Use 400 syntax for commands
      *         1=Use S/38 syntax for commands
     D  CPOPMsgRetKey                 4A
      *         The message retrieve key identifies a request message.  If
      *         prompting is requested, the request message identified by
      *         the message retrieve key is replaced by the updated command
      *         string.  If the message key contains all hexadecimal zeros
      *         or all blanks, no request message is updated.
     D  CPOPRes1                      9A
      *         This area must be set to hexadecimal zeros.
     D CPOP0100P       S                   LIKE(CPOP0100)
     D NewCmd          S          32702A
     D NewCmdLen       S             10I 0

      ***************************************************************************
      * Program Status Data Structure                                           *
      ***************************************************************************
      /If not defined(PSDS)
      /INCLUDE ROUTINES/QRPGLESRC,PSDS
      /EndIf

      ***************************************************************************
      * File Information Data Structure                                         *
      ***************************************************************************
      /If not defined(FILEINFDS)
      /INCLUDE ROUTINES/QRPGLESRC,FILEINFDS
      /EndIf

      * Used to check for command function keys
      * Takes field CFKey from position 369 of the file information data structure
      * (see above INCLUDE)
      * Sample use:  Select;
      *              When CFKey=F01;
      *                ...
      *              When CFKey=F03;
      *                ...
      *              EndSl;
      /If not defined(FKEYS)
      /INCLUDE ROUTINES/QRPGLESRC,FKEYS
      /EndIf

      ***************************************************************************
      * Common variables                                                        *
      ***************************************************************************
     D Apostrophe      S              1A   inz(x'7D')
     D Apos            S              1A   inz(x'7D')
     D All0            S             30A   inz(*All'0')
     D CmdStatus       S                   like(PGM_STATUS)
     D APIFormat       S              8A
     D Binary4         S              9B 0
     D Library         S             10A
     D Obj_Lib         S             20A
     D ObjName         S             10A
     D BrkMsg          S            500A
     D UserId          S             10A
     D Fax#            s             30a
     D* eMessage is commonly used for the command SNDEMAIL.
     D* Formatting controls include:
     D* <eol>, <EOL>, <nl>, <NL> all equal a CRLF or carriage return / Line feed
     D* <tab>, <TAB> both equal a tab
     D eMessage        s           2048a   varying
     D eSubject        s           2048a   varying
     D CRLF            S              2A   Inz(X'0D25')
     D*tab             s              1a   Inz(X'05')

      * End of Copy Book SRVPGMCPY.
      ********************************************************************** 